<?php

namespace App\Controller;

use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/repartition_des_ventes_par_region", name="repartition_des_ventes_par_region")
 */

class   RepartitionDesVentesParRegion extends AbstractController{
  /**
     * Entity Manager
     */
    private $em;
    /**
     * Creates a new instance of NombreDeVenteParJMA
     */
    public function __construct(EntityManagerInterface $em) {
        $this->em = $em;
    }
    
    public function __invoke(Request $data) { 
   
        $anneeFiltre = $data->query->get('anneeFiltre');
        $query = "  SELECT
                        COUNT(valeurs_fonciere.nature_mutation) AS nombre_de_vente,
                         valeurs_fonciere.region AS region
                    FROM
                        App:ValeursFonciere AS valeurs_fonciere
                    WHERE
                        lower(valeurs_fonciere.nature_mutation) = 'vente'
                        AND
                        TO_CHAR(valeurs_fonciere.date_mutation, 'YYYY') = '$anneeFiltre'
                    GROUP BY 
                    region
                   ORDER BY
                   region";
                
                    
        $nombreVentes = $this->em->createQuery($query)->getResult();
        foreach ($nombreVentes as &$nombreVente){
            $nombreVente['nombre_de_vente'] = intval($nombreVente['nombre_de_vente']);
            $nombreVente['region'] =  $nombreVente["region"];
        }
        $res = new JsonResponse(
            $nombreVentes,
            Response::HTTP_OK
        );
        return $res;
    }
}