import React from "react";
import ReactDOM from "react-dom";
import * as d3 from "d3";
import PieSVG from "../../Helpers/PieSVG";

class  Repartitiondesventesparregion extends React.Component {
	constructor(props) {
	  super(props);
  
	  this.state = {annee: '2018',data: []};
	  
	};
  
	componentWillMount(){
		console.log('Je suis appeler en premier!');
	  }

	  getData(){
		fetch(`https://${document.domain}:8443/repartitionDesVentesParRegion?anneeFiltre=${this.state.annee}`)
		  .then(response => {
			if (response.ok) {
			  const data = response.json()
			  return data;
			} else {
			  throw new Error('Something went wrong ...');
			}
		  })
		  .then(data => {
			this.setState({data: data });
		  })
		  .catch(error => console.log("error"));
	  }
	
	  componentDidMount(){
		this.timerID = setInterval(
			() => this.getData(),
			1000
		  );
	
	  }

	handleChange(event) {
	  this.setState({ annee: event.target.value});
	};

	render() {

		function parseData(data) {
			var arr = [];
			data.map(function (thisList){
				arr.push({
					nombre_de_vente: thisList.nombre_de_vente | 0,
				    dat : thisList.dat 
				});
			})
			return arr;
		}

		const c  =parseData(this.state.data)

		  const generateData = () =>
		   c.map((item, index) => ({
			  index: index,
			  date: new Date(item.dat).toLocaleDateString('fr-FR', {day: 'numeric', year: 'numeric', month: 'long' }),
			  value: item.nombre_de_vente
			}));
		   
		  const data = generateData();
		  console.log(data)
		  
	  return (
	    <div>
		  <div>
        
		  <input type="text" onChange={this.handleChange.bind(this)}/>

        <span className="label">SVG Elements</span>
          <PieSVG
          data={data}
          width={200}
          height={200}
          innerRadius={60}
          outerRadius={100}
        />
      </div>
		  		
      </div>
	  );
	}
  }
  
  export default  Repartitiondesventesparregion;