import React, { Component } from 'react';
import * as d3 from 'd3'
import '../../Cascading_Style_Sheets/index.css';

class Prixmoyenparannee extends Component {

  constructor(props){
    super(props);
    this.state = {
      data: []
    }
  }
  componentWillMount(){
    console.log('Je suis appeler en premier!');
  }

  getData(){
    fetch(`https://${document.domain}:8443/prix_moyens`)
      .then(response => {
        if (response.ok) {
          const data = response.json()
          return data;
        } else {
          throw new Error('Something went wrong ...');
        }
      })
      .then(data => {
        this.setState({data: data });
      })
      .catch(error => console.log("error"));
  }

  componentDidMount(){
    this.getData();

  }
 
  render() {
    function parseData(data) {
      var arr = [];
      data.map(function (thisList){
          arr.push({
            annee: thisList.annee | 0,
            prix_moyen_m_carree : thisList.prix_moyen_m_carree 
          });
      })
      return arr;
  }

  function isInteger(n) {
    return n === +n && n === (n|0);
}

        const data =  parseData(this.state.data)
        console.log(data)

         const  margin = 30
         const width = 800, height = 500;

         const h = height - 2 * margin, w = width - 2 * margin
              
         //x scale
         const x = d3.scaleLinear()
           .domain(d3.extent(data, d => d.annee )) //domaine : [min,max] d'annee
           .range([margin, w])
         
         //y scale
         const y = d3.scaleLinear()
           .domain([0, d3.max(data, d => d.prix_moyen_m_carree)]) // domaine [0,max] de b (à partir de 0)
           .range([h, margin])
         
         //Générateur de lignes : chaque point est [x(d.annee), y(d.prix_moyen_m_carré)] où d est une ligne dans les données
         // et x, y sont des échelles (par exemple x(10) renvoie la valeur du pixel de 10 mis à l'échelle par x)
         const line = d3.line()
           .x(d => x(d.annee))
           .y(d => y(d.prix_moyen_m_carree))
           .curve(d3.curveCatmullRom.alpha(0.5)) //curve line
          
         const xTicks = x.ticks(6).map(d => (
             x(d) > margin && x(d) < w ? 
               <g transform={`translate(${x(d)},${h + margin})`}>  
                 <text>{(isInteger(d))? d:' '}</text>
                 <line x1='0' x1='0' y1='0' y2='5' transform="translate(0,-20)"/>
               </g>
             : null
         ))
     
         const yTicks = y.ticks(5).map(d => (
             y(d) > 10 && y(d) < h ? 
               <g transform={`translate(${margin},${y(d)})`}>  
                 <text x="-12" y="5">{d}</text>
                 <line x1='0' x1='5' y1='0' y2='0' transform="translate(-5,0)"/>
                 <line className='gridline' x1='0' x1={w - margin} y1='0' y2='0' transform="translate(-5,0)"/> 
               </g>
             : null
         ))
     
         return  (
           <center>
           <svg width={width} height={height}>
              <line className="axis" x1={margin} x2={w} y1={h} y2={h}/>
              <line className="axis" x1={margin} x2={margin} y1={margin} y2={h}/>
              <path d={line(data)}/>
              <g className="axis-labels">
                {xTicks}
              </g>
              <g className="axis-labels">
                {yTicks}
              </g>
           </svg>
           </center>
         )
       }
     }
     
export default Prixmoyenparannee;

